<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\SUP\Util\SupUtilities;

class Sup09400DadosDoFornecedorEcommerceEmail 
{
    protected $crudService;
    protected $smtpUtil;
    protected $entityManager;
    protected $connection;
    protected $fileServerURL;
    protected $environment;
    protected $supUtilities;
    
    public function __construct($crudService, $smtpUtil, $entityManager, $connection, $fileServerURL, $environment, SupUtilities $supUtilities)
    {
        $this->crudService   = $crudService;
        $this->smtpUtil      = $smtpUtil;
        $this->entityManager = $entityManager;
        $this->connection    = $connection;
        $this->fileServerURL = $fileServerURL;
        $this->environment = $environment;
        $this->supUtilities = $supUtilities;
        
        $this->templatesDir  = realpath(__DIR__ . '/../../../../../Util/Template');
	}
	
	public function enviaEmailPCCronJob($arrayEmails, $row)
	{
	    if ($arrayEmails) {
	        $attrImg = 'width="200px"';
    	    $srcLogo = $this->supUtilities->returnLogo('PORTAL E-COMMERCE');
            $this->supUtilities->getLogoAttributes($srcLogo, $attrImg);
            $lgpd = $this->supUtilities->returnLgpd($row['FILIAL_LOGADA']);
            
            $subject = 'Notificação de Pedido de Coleta';
            $assunto = "<p class='bold' style='text-align: center; color: #ED2424'>Notificação de Pedidos Não Lidos</p>";
            
            foreach ($arrayEmails as $index => $fornecedores) {
                $mensagem = '';
                $mensagem .= '<p>' . $row['P_TXEMAILNOTIFIC'] . ' </p>
                            <ul>';
                
                foreach ($fornecedores as $index2 => $datas) {
                    $mensagem .= '<li>Data de Expiração - '.$index2.'</li>
                                    <ul>';
                    foreach ($datas as $index3 => $pedidos) {
                        $mensagem .= '<li>Pedido: '.$pedidos['NRPEDIDOCOL'].' - '.$pedidos['NMOPERADOR'].'</li>';
                        $mensagem .= '<li>Validade: '.$pedidos['DTINIPERGERAL'].' a '.$pedidos['DTFINPERGERAL'].'</li>';
                        $cdForneced = $pedidos['CDFORNECED'];
                    }
                    $mensagem .= '</ul>';
                }
                $mensagem .= '</ul>';
                $emails = $this->getEmailsFornecedores($cdForneced);
                
                if($emails) {
                    $messageSendMail = $this->supUtilities->returnMessageSendMail($srcLogo, $assunto, $mensagem, $attrImg, $lgpd);
                    $this->supUtilities->enviaEmail($row['EMAIL_LOGADO'], $subject, $emails, $messageSendMail, $emails);
                }
            }
	    }
	}
	
	public function enviaEmailAFCronJob($arrayEmails, $row)
	{
	    if ($arrayEmails) {
    	    $attrImg = 'width="200px"';
    	    $srcLogo = $this->supUtilities->returnLogo('PORTAL E-COMMERCE');
            $this->supUtilities->getLogoAttributes($srcLogo, $attrImg);
            $lgpd = $this->supUtilities->returnLgpd($row['FILIAL_LOGADA']);
            
            $subject = 'Notificação de AFs';
            $assunto = "<p class='bold' style='text-align: center; color: #ED2424'>Notificação de AFs Não Lidas</p>";
            
            foreach ($arrayEmails as $index => $fornecedores) {
                $mensagem = '';
                $mensagem .= '<p>' . $row['P_TXEMAILNOTIFIC'] . ' </p>
                            <ul>';
                
                foreach ($fornecedores as $index2 => $datas) {
                    $mensagem .= '<li>Data de Entrega - '.$index2.'</li>
                                    <ul>';
                    foreach ($datas as $index3 => $filiais) {
                        $mensagem .= '<li>Unidade - '.$index3.'</li>
                                        <ul>';
                        foreach($filiais as $index4 => $dadosAfs) {
                            $mensagem .= '<li>Número da AF: '.$dadosAfs['NRAUTOFORN'].'</li>';
                            
                            $cdForneced = $dadosAfs['CDFORNECED'];
                        }
                        
                        $mensagem .= '</ul><br/>';
                    }
                    $mensagem .= '</ul>';
                }
                $mensagem .= '</ul>';
                $emails = $this->getEmailsFornecedores($cdForneced);
                
                if($emails) {
                    $messageSendMail = $this->supUtilities->returnMessageSendMail($srcLogo, $assunto, $mensagem, $attrImg, $lgpd);
                    $this->supUtilities->enviaEmail($row['EMAIL_LOGADO'], $subject, $emails, $messageSendMail, $emails);
                }
            }
	    }
	}
	
    public function getEmailsFornecedores($cdForneced)
    {
        $sql = "SELECT DSLOGINECO FROM DADOSFORNECOMMERCE WHERE CDFORNECED = :P_CDFORNECED";
        $stmt = $this->entityManager->getConnection()->prepare($sql);
        $stmt->execute(
            array(
                "P_CDFORNECED" => $cdForneced
            )
        );
        
        $result = $stmt->fetchAll();
        
        if(isset($result[0])) {
            $emailsArrayMap = array_map(function($array){
                return $array['DSLOGINECO'];
            }, $result);
            
            return $emailsArrayMap;
        }
        
        return false;
    }
	
    public function getLinkPortal($nrOrg, $cdFilial)
    {
        $params = array(
            "P_CDFILIAL"     => $cdFilial,
            "P_IDATIVO"      => 'S',
            "P_NRORG"        => $nrOrg,
        );
        
        $sql = "SELECT 
                    PARAMGERALECOMMERCE.DSLINKECOMMERCE 
                FROM 
                    PARAMGERALECOMMERCE, FILIAL
                WHERE
                    FILIAL.CDFILIAL = :P_CDFILIAL AND
                    PARAMGERALECOMMERCE.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AND
                    PARAMGERALECOMMERCE.IDATIVO = :P_IDATIVO AND
                    PARAMGERALECOMMERCE.NRORG = :P_NRORG";
                    
        $linkPortal = $this->entityManager->getConnection()->fetchAll($sql, $params);
        
        return count($linkPortal) ? $linkPortal[0]['DSLINKECOMMERCE'] : false;
    }
	
	public function montaMensagemEmail($cabecalhoHTML, $dadosAcessoHTML, $permissoesHTML)
	{
	    $mensagem = "<table cellpadding='0' cellspacing='0' style='width:548px'> 
				        <tbody>
        					" . $cabecalhoHTML . "
        					" . $dadosAcessoHTML . "
        					" . $permissoesHTML . "
        					<tr class='footer'> 
        						<td> 
        							<center> 
        								<br><p class='bold'>Email automático enviado pelo TecFood.</p>
        							</center> 
        						</td>
        					</tr>
        				</tbody>
    				</table>";
	    
	    return $mensagem;
	}
	
    public function getCabecalho($dadosMensagem, $motivo, &$assunto, $linkPortal = '') 
    {
        $textoAdicional = '';
        $assunto = "<p class='bold' style='text-align: center; color: #ED2424'>Aviso Importante!</p>";
        
        switch($motivo) {
            case 'exclusao':
                $textoAlterado = 'excluiu seu acesso ao';
                $textoAdicional = "<tr> 
                    					<td class='description'> 
                    						<div>A partir de agora você não conseguirá mais acessá-lo.</div>
                    					</td>
                    				</tr>";
            break;
            
            case 'edicao_permissao':
                $textoAlterado = 'alterou suas permissões em nosso';
            break;
            
            case 'edicao_senha':
                $textoAlterado = 'alterou sua senha de acesso ao';
                $textoAdicional = " <tr> 
                    					<td class='description'> 
                    						<div>A senha <b>deverá</b> ser alterada após o primeiro acesso.</div>
                    					</td>
                    				</tr>";
            break;
            
            default:
                $linkHTML = '';
                
                if ($linkPortal) {
                    $linkHTML = "<tr>
                				    <td class='description'>
                				        <div style='padding-top: 10px;'>Para acessá-lo, clique neste <a style='color: #005A95 !important' href='" . $linkPortal . "' target='_blank'>link</a></div>
                				    <td>
                				</tr>";
                }
                
                $textoAlterado = 'incluiu seu acesso ao';
                $assunto = "<p class='bold' style='text-align: center'>Bem vindo ao <br/> Portal E-Commerce!</p>";
                $textoAdicional = " <tr> 
                    					<td class='description'> 
                    						<div>A senha <b>deverá</b> ser alterada após o primeiro acesso.</div>
                    					</td>
                    				</tr>"
                    				.$linkHTML;
        }
        
        return "<tr> 
					<td class='title description' style='padding-bottom: 10px;'> 
                        <b>" . $dadosMensagem['operador'] . "</b> " . $textoAlterado . " nosso portal em 
                        <b><span class='Object' id='OBJ_PREFIX_DWT71_com_zimbra_date'>" . $dadosMensagem['data'] . "</span></b>.
                    </td>
				</tr>"
				.$textoAdicional;
    }
    
    public function getDadosAcesso($dadosMensagem) 
    {
        return "<tr>
    				<td class='title' style='padding-top: 20px; font-weight: bold; border-bottom: 1px solid #000;'> 
    					<div>Dados de acesso</div>
    				</td>
    			</tr>
    			<tr> 
    				<td class='description'> 
    					<div class='divTable' style='padding-top: 5px;'> 
    						<div style='float: left;width: 20%;'>
    							E-mail:
    						</div>
    						<div style='float: right;width: 80%;'>
    							<i>". $dadosMensagem['email'] ."</i>
    						</div>
    					</div>
    					<div class='divTable' style='padding-top: 23px;'> 
    						<div style='float: left;width: 20%;'>
    							Senha:
    						</div>
    						<div style='float: right;width: 80%;'>
    							<i>". $dadosMensagem['senha'] ."</i>
    						</div>
    					</div>
    				</td>
    			</tr>";
    }
	
	public function getPermissoes($dadosMensagem) 
	{
	    return "<tr> 
					<td class='title'> 
						<div style='padding-top: 20px; font-weight: bold; border-bottom: 1px solid #000;'>
							Permissões
						</div>
					</td>
				</tr>
                <tr> 
    				<td class='description'> 
    					<div class='divTable' style='padding-top: 5px;'> 
    						<div style='float: left;width: 50%;'>
    							Autorização de Fornecimento:
    						</div>
    						<div style='float: right;width: 50%;'>
    							<i>". $dadosMensagem['idAcessoAF'] ."</i>
    						</div>
    					</div>
    					<div class='divTable' style='padding-top: 23px;'> 
    						<div style='float: left;width: 50%;'>
    							Contas a Receber:
    						</div>
    						<div style='float: right;width: 50%;'>
    							<i>". $dadosMensagem['idAcessoCR'] ."</i>
    						</div>
    					</div>
    					<div class='divTable' style='padding-top: 23px;'> 
    						<div style='float: left;width: 50%;'>
    							Pedido de Cotação:
    						</div>
    						<div style='float: right;width: 50%;'>
    							<i>". $dadosMensagem['idAcessoCOT'] ."</i>
    						</div>
    					</div>
    					<div class='divTable' style='padding-top: 23px;'> 
    						<div style='float: left;width: 50%;'>
    							Meus Produtos:
    						</div>
    						<div style='float: right;width: 50%;'>
    							<i>". $dadosMensagem['idAcessoProd'] ."</i>
    						</div>
    					</div>
    				</td>
    			</tr>";
	}
	
	public function enviarEmail($row, $response) 
	{
        try {
            if ($row['MOTIVO_EMAIL'] != '') {
                $permissoes = array(
                    "S" => "Autorizada",
                    "N" => "Não autorizada"
                );
                
                $dadosMensagem = array(
                    'data'         => date("d/m/Y"),
                    'address'      => $row["DSLOGINECO"],
                    'operador'     => $row["OPERLOGADO"],
                    'email'        => $row["DSLOGINECO"],
                    'senha'        => $row["CDSENHAWEB"],
                    'idAcessoAF'   => $permissoes[$row["IDACESSOAF"]],
                    'idAcessoCR'   => $permissoes[$row["IDACESSOCR"]],
                    'idAcessoCOT'  => $permissoes[$row["IDACESSOCOT"]],
                    'idAcessoProd' => $permissoes[$row["IDACESSOUPLOAD"]],
                    'motivo'       => $row["MOTIVO_EMAIL"]
                );
                
                $assunto = "";
                $permissoesHTML = "";
                $dadosAcessoHTML = "";
                
                switch ($dadosMensagem['motivo']) {
                    case 'exclusao':
                        $subject = "Exclusão de Acesso ao Portal";
                        $cabecalhoHTML = $this->getCabecalho($dadosMensagem, 'exclusao', $assunto);
                    break;
                        
                    case 'edicao_permissao':
                        $subject = "Alteração nas Permissões de Acesso";
                        $cabecalhoHTML = $this->getCabecalho($dadosMensagem, 'edicao_permissao', $assunto);
                        $permissoesHTML = $this->getPermissoes($dadosMensagem);
                    break;
                    
                    case 'edicao_senha':
                        $subject = "Alteração de Senha";
                        $cabecalhoHTML = $this->getCabecalho($dadosMensagem, 'edicao_senha', $assunto);
                        $dadosAcessoHTML = $this->getDadosAcesso($dadosMensagem);
                    break;
                    
                    case 'adicao':
                        $subject = "Inclusão de Acesso ao Portal";
                        $linkPortal = $this->getLinkPortal($row['NRORG'], $row['CDFILIAL']);
                        $cabecalhoHTML = $this->getCabecalho($dadosMensagem, 'inclusao', $assunto, $linkPortal);
                        $dadosAcessoHTML = $this->getDadosAcesso($dadosMensagem);
                        $permissoesHTML = $this->getPermissoes($dadosMensagem);
                    break;
                }
                
                $mensagem = $this->montaMensagemEmail($cabecalhoHTML, $dadosAcessoHTML, $permissoesHTML);
                
                $messageSendMail = $this->supUtilities->messageSendMail($row['CDFILIAL'], $assunto, $mensagem, 'PORTAL E-COMMERCE');
                $this->supUtilities->enviaEmail($row['EMAIL_LOGADO'], $subject, $row["DSLOGINECO"], $messageSendMail, $dadosMensagem['email']);
            }
        } catch (\Exception $e) {
            $response->setError(new Error ($e->getMessage(), 'SMTP'));
        }
	}
}