<?php
namespace Teknisa\SUP\Modules\Fornecimento\Modules\EmissaoAF\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup00800AfsInconsistenteForaLimiteController extends \Zeedhi\Framework\Controller\Report
{
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $stExtensao;
    protected $environment;
    protected $newCode;
    
    public function __construct($reportService,$qr2Strategy, $environment, $newCode, $connection)
    {
        parent::__construct($reportService);
        $this->qr2Strategy   =   $qr2Strategy;
        $this->environment   = $environment;
        $this->newCode       = $newCode;
        $this->connection    = $connection;
    }
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $nomeRelatorio = explode(".",$row['RELATORIO']);
        if($nomeRelatorio[1] == "BIRT") {
            if($row['L_CDOPERADOR1'] != 'T'){
                $nrlistaComp = $this->criarListaValores($row['L_CDOPERADOR1']);
                $L_LISTACOMP = "_NRLISTA=".$nrlistaComp;
                $row['L_CDOPERADOR1'] = $L_LISTACOMP;
                $row['L_CDOPERADOR2'] = $L_LISTACOMP;
            } 
            if($row['L_CDREGIAO1'] != 'T'){
                $nrlistaReg = $this->criarListaValores($row['L_CDREGIAO1']);
                $L_LISTAREG = "_NRLISTA=".$nrlistaReg;
                $row['L_CDREGIAO1'] = $L_LISTAREG;
                $row['L_CDREGIAO2'] = $L_LISTAREG;
            }
            if($row['L_CDFILDEST1'] != 'T'){
                $nrlistaFil = $this->criarListaValores($row['L_CDFILDEST1']);
                $L_LISTAFIL = "_NRLISTA=".$nrlistaFil;
                $row['L_CDFILDEST1'] = $L_LISTAFIL;
                $row['L_CDFILDEST2'] = $L_LISTAFIL;
                $row['L_CDFILDEST3'] = $L_LISTAFIL;
                $row['L_CDFILDEST4'] = $L_LISTAFIL;
            }
        }
        $this->reportMapping[$this->stNomeRel] =
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array (
                        "P_DATAINI1"       =>    "P_DTINI_INCOPRINCI1",
                        "P_DATAFIN1"       =>    "P_DTFIN_INCOPRINCI1",
                        "P_DATAINI2"       =>    "P_DTINI_INCOPRINCI2",
                        "P_DATAFIN2"       =>    "P_DTFIN_INCOPRINCI2",
                        "P_NRAUTOFORN1"    =>    "P_NRAUTOFORN_INCOPRINCI1",
                        "P_NRAUTOFORN2"    =>    "P_NRAUTOFORN_INCOPRINCI2",
                        "P_CDOPERADOR"     =>    "P_CDOPERADOR_INCOPRINCI",
                        "L_CDREGIAO1"      =>    "L_CDREGIAO_INCOPRINCI1",
                        "L_CDREGIAO2"      =>    "L_CDREGIAO_INCOPRINCI2",
                        "L_CDOPERADOR1"    =>    "L_CDOPERADOR_INCOPRINCI1",
                        "L_CDOPERADOR2"    =>    "L_CDOPERADOR_INCOPRINCI2",
                        "L_CDFILDEST1"     =>    "L_CDFILDEST_INCOPRINCI1",
                        "L_CDFILDEST2"     =>    "L_CDFILDEST_INCOPRINCI2",
                        "L_CDFILDEST3"     =>    "L_CDFILDEST_INCOPRINCI3",
                        "L_CDFILDEST4"     =>    "L_CDFILDEST_INCOPRINCI4",
                        "P_CDGRUPFILI1"    =>    "P_CDGRUPFILI_INCOPRINCI1",
                        "P_CDGRUPFILI2"    =>    "P_CDGRUPFILI_INCOPRINCI2",
                        "P_NRORG"          =>    "P_NRORG"
                    ),
            );
    }
    
    protected function criarListaValores($lista){
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrg());
        $valores = explode('_',$lista);
        try{
            foreach($valores as $key){
                $this->insertLista($nrlista, $key);
            }
            return $nrlista;
        } catch(\Exception $e){
            throw $e;
        }
     }

     public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );

        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}
